#!/usr/bin/env python




##################################################
## DEPENDENCIES
import sys
import os
import os.path
try:
    import builtins as builtin
except ImportError:
    import __builtin__ as builtin
from os.path import getmtime, exists
import time
import types
from Cheetah.Version import MinCompatibleVersion as RequiredCheetahVersion
from Cheetah.Version import MinCompatibleVersionTuple as RequiredCheetahVersionTuple
from Cheetah.Template import Template
from Cheetah.DummyTransaction import *
from Cheetah.NameMapper import NotFound, valueForName, valueFromSearchList, valueFromFrameOrSearchList
from Cheetah.CacheRegion import CacheRegion
import Cheetah.Filters as Filters
import Cheetah.ErrorCatchers as ErrorCatchers
from xpdeint.Geometry.NonUniformDimensionRepresentation import NonUniformDimensionRepresentation

##################################################
## MODULE CONSTANTS
VFFSL=valueFromFrameOrSearchList
VFSL=valueFromSearchList
VFN=valueForName
currentTime=time.time
__CHEETAH_version__ = '2.4.4'
__CHEETAH_versionTuple__ = (2, 4, 4, 'development', 0)
__CHEETAH_genTime__ = 1515434836.000000
__CHEETAH_genTimestamp__ = 'Mon, 08 Jan 2018 18:07:16 -0200'
__CHEETAH_src__ = 'HermiteGaussDimensionRepresentation.tmpl'
__CHEETAH_srcLastModified__ = 'Wed Jul 11 09:41:11 2012'
__CHEETAH_docstring__ = 'Autogenerated by Cheetah: The Python-Powered Template Engine'

if __CHEETAH_versionTuple__ < RequiredCheetahVersionTuple:
    raise AssertionError(
      'This template was compiled with Cheetah version'
      ' %s. Templates compiled before version %s must be recompiled.'%(
         __CHEETAH_version__, RequiredCheetahVersion))

##################################################
## CLASSES

class HermiteGaussDimensionRepresentation(NonUniformDimensionRepresentation):

    ##################################################
    ## CHEETAH GENERATED METHODS


    def __init__(self, *args, **KWs):

        super(HermiteGaussDimensionRepresentation, self).__init__(*args, **KWs)
        if not self._CHEETAH__instanceInitialized:
            cheetahKWArgs = {}
            allowedKWs = 'searchList namespaces filter filtersLib errorCatcher'.split()
            for k,v in KWs.items():
                if k in allowedKWs: cheetahKWArgs[k] = v
            self._initCheetahInstance(**cheetahKWArgs)
        

    def gridAtIndex(self, index, **KWS):



        ## CHEETAH: generated from @def gridAtIndex($index) at line 27, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        write(u'''_hermite_zeros_''')
        _v = VFFSL(SL,"parent.name",True) # u'${parent.name}' on line 29, col 16
        if _v is not None: write(_filter(_v, rawExpr=u'${parent.name}')) # from line 29, col 16.
        write(u'''[''')
        _v = VFFSL(SL,"index",True) # u'$index' on line 29, col 31
        if _v is not None: write(_filter(_v, rawExpr=u'$index')) # from line 29, col 31.
        write(u'''] * ''')
        _v = VFFSL(SL,"_maximum",True) # u'${_maximum}' on line 29, col 41
        if _v is not None: write(_filter(_v, rawExpr=u'${_maximum}')) # from line 29, col 41.
        write(u''' / sqrt(''')
        _v = VFFSL(SL,"fieldCount",True) / 2.0 # u'${fieldCount / 2.0}' on line 29, col 60
        if _v is not None: write(_filter(_v, rawExpr=u'${fieldCount / 2.0}')) # from line 29, col 60.
        write(u''')''')
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def stepWeightAtIndex(self, index, **KWS):



        ## CHEETAH: generated from @def stepWeightAtIndex($index) at line 33, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        write(u'''_hermite_gauss_weights_''')
        _v = VFFSL(SL,"parent.name",True) # u'${parent.name}' on line 35, col 24
        if _v is not None: write(_filter(_v, rawExpr=u'${parent.name}')) # from line 35, col 24.
        write(u'''[''')
        _v = VFFSL(SL,"index",True) # u'$index' on line 35, col 39
        if _v is not None: write(_filter(_v, rawExpr=u'$index')) # from line 35, col 39.
        write(u'''] * ''')
        _v = VFFSL(SL,"_maximum",True) # u'${_maximum}' on line 35, col 49
        if _v is not None: write(_filter(_v, rawExpr=u'${_maximum}')) # from line 35, col 49.
        write(u''' / sqrt(''')
        _v = VFFSL(SL,"fieldCount",True) / 2.0 # u'${fieldCount / 2.0}' on line 35, col 68
        if _v is not None: write(_filter(_v, rawExpr=u'${fieldCount / 2.0}')) # from line 35, col 68.
        write(u''')''')
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def indexForSinglePointSample(self, **KWS):



        ## CHEETAH: generated from @def indexForSinglePointSample at line 39, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        #  Take the middle point, which is in the middle of the array
        _v = VFFSL(SL,"globalLattice",True) # u'${globalLattice}' on line 42, col 1
        if _v is not None: write(_filter(_v, rawExpr=u'${globalLattice}')) # from line 42, col 1.
        write(u'''/2''')
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def createCoordinateVariableForSinglePointSample(self, **KWS):



        ## CHEETAH: generated from @def createCoordinateVariableForSinglePointSample at line 46, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        _v = VFFSL(SL,"type",True) # u'${type}' on line 48, col 1
        if _v is not None: write(_filter(_v, rawExpr=u'${type}')) # from line 48, col 1.
        write(u''' ''')
        _v = VFFSL(SL,"name",True) # u'${name}' on line 48, col 9
        if _v is not None: write(_filter(_v, rawExpr=u'${name}')) # from line 48, col 9.
        write(u''' = ''')
        _v = VFFSL(SL,"arrayName",True) # u'${arrayName}' on line 48, col 19
        if _v is not None: write(_filter(_v, rawExpr=u'${arrayName}')) # from line 48, col 19.
        write(u'''[''')
        _v = VFFSL(SL,"globalLattice",True) # u'${globalLattice}' on line 48, col 32
        if _v is not None: write(_filter(_v, rawExpr=u'${globalLattice}')) # from line 48, col 32.
        write(u'''/2];
#define d''')
        _v = VFFSL(SL,"name",True) # u'${name}' on line 49, col 10
        if _v is not None: write(_filter(_v, rawExpr=u'${name}')) # from line 49, col 10.
        write(u''' (''')
        _v = VFFSL(SL,"stepSizeArrayName",True) # u'${stepSizeArrayName}' on line 49, col 19
        if _v is not None: write(_filter(_v, rawExpr=u'${stepSizeArrayName}')) # from line 49, col 19.
        write(u'''[''')
        _v = VFFSL(SL,"globalLattice",True) # u'${globalLattice}' on line 49, col 40
        if _v is not None: write(_filter(_v, rawExpr=u'${globalLattice}')) # from line 49, col 40.
        write(u'''/2]  * (''')
        _v = VFFSL(SL,"volumePrefactor",True) # u'${volumePrefactor}' on line 49, col 64
        if _v is not None: write(_filter(_v, rawExpr=u'${volumePrefactor}')) # from line 49, col 64.
        write(u'''))
''')
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def writeBody(self, **KWS):



        ## CHEETAH: main method generated for this template
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        # HermiteGaussDimensionRepresentation.tmpl
        # 
        # Created by Graham Dennis on 2009-08-12.
        # 
        # Copyright (c) 2009-2012, Graham Dennis
        # 
        # This program is free software: you can redistribute it and/or modify
        # it under the terms of the GNU General Public License as published by
        # the Free Software Foundation, either version 2 of the License, or
        # (at your option) any later version.
        # 
        # This program is distributed in the hope that it will be useful,
        # but WITHOUT ANY WARRANTY; without even the implied warranty of
        # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        # GNU General Public License for more details.
        # 
        # You should have received a copy of the GNU General Public License
        # along with this program.  If not, see <http://www.gnu.org/licenses/>.
        # 
        write(u'''




''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        
    ##################################################
    ## CHEETAH GENERATED ATTRIBUTES


    _CHEETAH__instanceInitialized = False

    _CHEETAH_version = __CHEETAH_version__

    _CHEETAH_versionTuple = __CHEETAH_versionTuple__

    _CHEETAH_genTime = __CHEETAH_genTime__

    _CHEETAH_genTimestamp = __CHEETAH_genTimestamp__

    _CHEETAH_src = __CHEETAH_src__

    _CHEETAH_srcLastModified = __CHEETAH_srcLastModified__

    instanceAttributes = ['_maximum', 'fieldCount']

    instanceDefaults = {'fieldCount': 2.0}

    _mainCheetahMethod_for_HermiteGaussDimensionRepresentation= 'writeBody'

## END CLASS DEFINITION

if not hasattr(HermiteGaussDimensionRepresentation, '_initCheetahAttributes'):
    templateAPIClass = getattr(HermiteGaussDimensionRepresentation, '_CHEETAH_templateClass', Template)
    templateAPIClass._addCheetahPlumbingCodeToClass(HermiteGaussDimensionRepresentation)


# CHEETAH was developed by Tavis Rudd and Mike Orr
# with code, advice and input from many other volunteers.
# For more information visit http://www.CheetahTemplate.org/

##################################################
## if run from command line:
if __name__ == '__main__':
    from Cheetah.TemplateCmdLineIface import CmdLineIface
    CmdLineIface(templateObj=HermiteGaussDimensionRepresentation()).run()


